ebuild.sh: skip EBUILD_HOOK_DIR for depend phase
[portage.git] / bin / ebuild.sh
1 #!/bin/bash
2 # Copyright 1999-2012 Gentoo Foundation
3 # Distributed under the terms of the GNU General Public License v2
4
5 PORTAGE_BIN_PATH="${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"
6 PORTAGE_PYM_PATH="${PORTAGE_PYM_PATH:-/usr/lib/portage/pym}"
7
8 # Prevent aliases from causing portage to act inappropriately.
9 # Make sure it's before everything so we don't mess aliases that follow.
10 unalias -a
11
12 source "${PORTAGE_BIN_PATH}/isolated-functions.sh" || exit 1
13
14 if [[ $EBUILD_PHASE != depend ]] ; then
15         source "${PORTAGE_BIN_PATH}/phase-functions.sh" || die
16         source "${PORTAGE_BIN_PATH}/save-ebuild-env.sh" || die
17         source "${PORTAGE_BIN_PATH}/phase-helpers.sh" || die
18         source "${PORTAGE_BIN_PATH}/bashrc-functions.sh" || die
19 else
20         # These dummy functions are for things that are likely to be called
21         # in global scope, even though they are completely useless during
22         # the "depend" phase.
23         for x in diropts docompress exeopts get_KV insopts \
24                 keepdir KV_major KV_micro KV_minor KV_to_int \
25                 libopts register_die_hook register_success_hook \
26                 remove_path_entry set_unless_changed strip_duplicate_slashes \
27                 unset_unless_changed use_with use_enable ; do
28                 eval "${x}() {
29                         if has \"\${EAPI:-0}\" 4-python; then
30                                 die \"\${FUNCNAME}() calls are not allowed in global scope\"
31                         fi
32                 }"
33         done
34         # These dummy functions return false in older EAPIs, in order to ensure that
35         # `use multislot` is false for the "depend" phase.
36         for x in use useq usev ; do
37                 eval "${x}() {
38                         if has \"\${EAPI:-0}\" 4-python; then
39                                 die \"\${FUNCNAME}() calls are not allowed in global scope\"
40                         else
41                                 return 1
42                         fi
43                 }"
44         done
45         # These functions die because calls to them during the "depend" phase
46         # are considered to be severe QA violations.
47         for x in best_version has_version portageq ; do
48                 eval "${x}() { die \"\${FUNCNAME}() calls are not allowed in global scope\"; }"
49         done
50         unset x
51 fi
52
53 # Don't use sandbox's BASH_ENV for new shells because it does
54 # 'source /etc/profile' which can interfere with the build
55 # environment by modifying our PATH.
56 unset BASH_ENV
57
58 # This is just a temporary workaround for portage-9999 users since
59 # earlier portage versions do not detect a version change in this case
60 # (9999 to 9999) and therefore they try execute an incompatible version of
61 # ebuild.sh during the upgrade.
62 export PORTAGE_BZIP2_COMMAND=${PORTAGE_BZIP2_COMMAND:-bzip2} 
63
64 # These two functions wrap sourcing and calling respectively.  At present they
65 # perform a qa check to make sure eclasses and ebuilds and profiles don't mess
66 # with shell opts (shopts).  Ebuilds/eclasses changing shopts should reset them 
67 # when they are done.
68
69 qa_source() {
70         local shopts=$(shopt) OLDIFS="$IFS"
71         local retval
72         source "$@"
73         retval=$?
74         set +e
75         [[ $shopts != $(shopt) ]] &&
76                 eqawarn "QA Notice: Global shell options changed and were not restored while sourcing '$*'"
77         [[ "$IFS" != "$OLDIFS" ]] &&
78                 eqawarn "QA Notice: Global IFS changed and was not restored while sourcing '$*'"
79         return $retval
80 }
81
82 qa_call() {
83         local shopts=$(shopt) OLDIFS="$IFS"
84         local retval
85         "$@"
86         retval=$?
87         set +e
88         [[ $shopts != $(shopt) ]] &&
89                 eqawarn "QA Notice: Global shell options changed and were not restored while calling '$*'"
90         [[ "$IFS" != "$OLDIFS" ]] &&
91                 eqawarn "QA Notice: Global IFS changed and was not restored while calling '$*'"
92         return $retval
93 }
94
95 EBUILD_SH_ARGS="$*"
96
97 shift $#
98
99 # Unset some variables that break things.
100 unset GZIP BZIP BZIP2 CDPATH GREP_OPTIONS GREP_COLOR GLOBIGNORE
101
102 [[ $PORTAGE_QUIET != "" ]] && export PORTAGE_QUIET
103
104 # sandbox support functions; defined prior to profile.bashrc srcing, since the profile might need to add a default exception (/usr/lib64/conftest fex)
105 _sb_append_var() {
106         local _v=$1 ; shift
107         local var="SANDBOX_${_v}"
108         [[ -z $1 || -n $2 ]] && die "Usage: add$(echo ${_v} | \
109                 LC_ALL=C tr [:upper:] [:lower:]) <colon-delimited list of paths>"
110         export ${var}="${!var:+${!var}:}$1"
111 }
112 # bash-4 version:
113 # local var="SANDBOX_${1^^}"
114 # addread() { _sb_append_var ${0#add} "$@" ; }
115 addread()    { _sb_append_var READ    "$@" ; }
116 addwrite()   { _sb_append_var WRITE   "$@" ; }
117 adddeny()    { _sb_append_var DENY    "$@" ; }
118 addpredict() { _sb_append_var PREDICT "$@" ; }
119
120 addwrite "${PORTAGE_TMPDIR}"
121 addread "/:${PORTAGE_TMPDIR}"
122 [[ -n ${PORTAGE_GPG_DIR} ]] && addpredict "${PORTAGE_GPG_DIR}"
123
124 # Avoid sandbox violations in temporary directories.
125 if [[ -w $T ]] ; then
126         export TEMP=$T
127         export TMP=$T
128         export TMPDIR=$T
129 elif [[ $SANDBOX_ON = 1 ]] ; then
130         for x in TEMP TMP TMPDIR ; do
131                 [[ -n ${!x} ]] && addwrite "${!x}"
132         done
133         unset x
134 fi
135
136 # the sandbox is disabled by default except when overridden in the relevant stages
137 export SANDBOX_ON=0
138
139 esyslog() {
140         # Custom version of esyslog() to take care of the "Red Star" bug.
141         # MUST follow functions.sh to override the "" parameter problem.
142         return 0
143 }
144
145 # Ensure that $PWD is sane whenever possible, to protect against
146 # exploitation of insecure search path for python -c in ebuilds.
147 # See bug #239560.
148 if ! has "$EBUILD_PHASE" clean cleanrm depend help ; then
149         cd "$PORTAGE_BUILDDIR" || \
150                 die "PORTAGE_BUILDDIR does not exist: '$PORTAGE_BUILDDIR'"
151 fi
152
153 #if no perms are specified, dirs/files will have decent defaults
154 #(not secretive, but not stupid)
155 umask 022
156
157 # debug-print() gets called from many places with verbose status information useful
158 # for tracking down problems. The output is in $T/eclass-debug.log.
159 # You can set ECLASS_DEBUG_OUTPUT to redirect the output somewhere else as well.
160 # The special "on" setting echoes the information, mixing it with the rest of the
161 # emerge output.
162 # You can override the setting by exporting a new one from the console, or you can
163 # set a new default in make.*. Here the default is "" or unset.
164
165 # in the future might use e* from /etc/init.d/functions.sh if i feel like it
166 debug-print() {
167         # if $T isn't defined, we're in dep calculation mode and
168         # shouldn't do anything
169         [[ $EBUILD_PHASE = depend || ! -d ${T} || ${#} -eq 0 ]] && return 0
170
171         if [[ ${ECLASS_DEBUG_OUTPUT} == on ]]; then
172                 printf 'debug: %s\n' "${@}" >&2
173         elif [[ -n ${ECLASS_DEBUG_OUTPUT} ]]; then
174                 printf 'debug: %s\n' "${@}" >> "${ECLASS_DEBUG_OUTPUT}"
175         fi
176
177         if [[ -w $T ]] ; then
178                 # default target
179                 printf '%s\n' "${@}" >> "${T}/eclass-debug.log"
180                 # let the portage user own/write to this file
181                 chgrp portage "${T}/eclass-debug.log" &>/dev/null
182                 chmod g+w "${T}/eclass-debug.log" &>/dev/null
183         fi
184 }
185
186 # The following 2 functions are debug-print() wrappers
187
188 debug-print-function() {
189         debug-print "${1}: entering function, parameters: ${*:2}"
190 }
191
192 debug-print-section() {
193         debug-print "now in section ${*}"
194 }
195
196 # Sources all eclasses in parameters
197 declare -ix ECLASS_DEPTH=0
198 inherit() {
199         ECLASS_DEPTH=$(($ECLASS_DEPTH + 1))
200         if [[ ${ECLASS_DEPTH} > 1 ]]; then
201                 debug-print "*** Multiple Inheritence (Level: ${ECLASS_DEPTH})"
202         fi
203
204         if [[ -n $ECLASS && -n ${!__export_funcs_var} ]] ; then
205                 echo "QA Notice: EXPORT_FUNCTIONS is called before inherit in" \
206                         "$ECLASS.eclass. For compatibility with <=portage-2.1.6.7," \
207                         "only call EXPORT_FUNCTIONS after inherit(s)." \
208                         | fmt -w 75 | while read -r ; do eqawarn "$REPLY" ; done
209         fi
210
211         local location
212         local olocation
213         local x
214
215         # These variables must be restored before returning.
216         local PECLASS=$ECLASS
217         local prev_export_funcs_var=$__export_funcs_var
218
219         local B_IUSE
220         local B_REQUIRED_USE
221         local B_DEPEND
222         local B_RDEPEND
223         local B_PDEPEND
224         while [ "$1" ]; do
225                 location="${ECLASSDIR}/${1}.eclass"
226                 olocation=""
227
228                 export ECLASS="$1"
229                 __export_funcs_var=__export_functions_$ECLASS_DEPTH
230                 unset $__export_funcs_var
231
232                 if [ "${EBUILD_PHASE}" != "depend" ] && \
233                         [ "${EBUILD_PHASE}" != "nofetch" ] && \
234                         [[ ${EBUILD_PHASE} != *rm ]] && \
235                         [[ ${EMERGE_FROM} != "binary" ]] ; then
236                         # This is disabled in the *rm phases because they frequently give
237                         # false alarms due to INHERITED in /var/db/pkg being outdated
238                         # in comparison the the eclasses from the portage tree. It's
239                         # disabled for nofetch, since that can be called by repoman and
240                         # that triggers bug #407449 due to repoman not exporting
241                         # non-essential variables such as INHERITED.
242                         if ! has $ECLASS $INHERITED $__INHERITED_QA_CACHE ; then
243                                 eqawarn "QA Notice: ECLASS '$ECLASS' inherited illegally in $CATEGORY/$PF $EBUILD_PHASE"
244                         fi
245                 fi
246
247                 # any future resolution code goes here
248                 if [ -n "$PORTDIR_OVERLAY" ]; then
249                         local overlay
250                         for overlay in ${PORTDIR_OVERLAY}; do
251                                 olocation="${overlay}/eclass/${1}.eclass"
252                                 if [ -e "$olocation" ]; then
253                                         location="${olocation}"
254                                         debug-print "  eclass exists: ${location}"
255                                 fi
256                         done
257                 fi
258                 debug-print "inherit: $1 -> $location"
259                 [ ! -e "$location" ] && die "${1}.eclass could not be found by inherit()"
260
261                 if [ "${location}" == "${olocation}" ] && \
262                         ! has "${location}" ${EBUILD_OVERLAY_ECLASSES} ; then
263                                 EBUILD_OVERLAY_ECLASSES="${EBUILD_OVERLAY_ECLASSES} ${location}"
264                 fi
265
266                 #We need to back up the value of DEPEND and RDEPEND to B_DEPEND and B_RDEPEND
267                 #(if set).. and then restore them after the inherit call.
268
269                 #turn off glob expansion
270                 set -f
271
272                 # Retain the old data and restore it later.
273                 unset B_IUSE B_REQUIRED_USE B_DEPEND B_RDEPEND B_PDEPEND
274                 [ "${IUSE+set}"       = set ] && B_IUSE="${IUSE}"
275                 [ "${REQUIRED_USE+set}" = set ] && B_REQUIRED_USE="${REQUIRED_USE}"
276                 [ "${DEPEND+set}"     = set ] && B_DEPEND="${DEPEND}"
277                 [ "${RDEPEND+set}"    = set ] && B_RDEPEND="${RDEPEND}"
278                 [ "${PDEPEND+set}"    = set ] && B_PDEPEND="${PDEPEND}"
279                 unset IUSE REQUIRED_USE DEPEND RDEPEND PDEPEND
280                 #turn on glob expansion
281                 set +f
282
283                 qa_source "$location" || die "died sourcing $location in inherit()"
284                 
285                 #turn off glob expansion
286                 set -f
287
288                 # If each var has a value, append it to the global variable E_* to
289                 # be applied after everything is finished. New incremental behavior.
290                 [ "${IUSE+set}"         = set ] && E_IUSE+="${E_IUSE:+ }${IUSE}"
291                 [ "${REQUIRED_USE+set}" = set ] && E_REQUIRED_USE+="${E_REQUIRED_USE:+ }${REQUIRED_USE}"
292                 [ "${DEPEND+set}"       = set ] && E_DEPEND+="${E_DEPEND:+ }${DEPEND}"
293                 [ "${RDEPEND+set}"      = set ] && E_RDEPEND+="${E_RDEPEND:+ }${RDEPEND}"
294                 [ "${PDEPEND+set}"      = set ] && E_PDEPEND+="${E_PDEPEND:+ }${PDEPEND}"
295
296                 [ "${B_IUSE+set}"     = set ] && IUSE="${B_IUSE}"
297                 [ "${B_IUSE+set}"     = set ] || unset IUSE
298                 
299                 [ "${B_REQUIRED_USE+set}"     = set ] && REQUIRED_USE="${B_REQUIRED_USE}"
300                 [ "${B_REQUIRED_USE+set}"     = set ] || unset REQUIRED_USE
301
302                 [ "${B_DEPEND+set}"   = set ] && DEPEND="${B_DEPEND}"
303                 [ "${B_DEPEND+set}"   = set ] || unset DEPEND
304
305                 [ "${B_RDEPEND+set}"  = set ] && RDEPEND="${B_RDEPEND}"
306                 [ "${B_RDEPEND+set}"  = set ] || unset RDEPEND
307
308                 [ "${B_PDEPEND+set}"  = set ] && PDEPEND="${B_PDEPEND}"
309                 [ "${B_PDEPEND+set}"  = set ] || unset PDEPEND
310
311                 #turn on glob expansion
312                 set +f
313
314                 if [[ -n ${!__export_funcs_var} ]] ; then
315                         for x in ${!__export_funcs_var} ; do
316                                 debug-print "EXPORT_FUNCTIONS: $x -> ${ECLASS}_$x"
317                                 declare -F "${ECLASS}_$x" >/dev/null || \
318                                         die "EXPORT_FUNCTIONS: ${ECLASS}_$x is not defined"
319                                 eval "$x() { ${ECLASS}_$x \"\$@\" ; }" > /dev/null
320                         done
321                 fi
322                 unset $__export_funcs_var
323
324                 has $1 $INHERITED || export INHERITED="$INHERITED $1"
325
326                 shift
327         done
328         ((--ECLASS_DEPTH)) # Returns 1 when ECLASS_DEPTH reaches 0.
329         if (( ECLASS_DEPTH > 0 )) ; then
330                 export ECLASS=$PECLASS
331                 __export_funcs_var=$prev_export_funcs_var
332         else
333                 unset ECLASS __export_funcs_var
334         fi
335         return 0
336 }
337
338 # Exports stub functions that call the eclass's functions, thereby making them default.
339 # For example, if ECLASS="base" and you call "EXPORT_FUNCTIONS src_unpack", the following
340 # code will be eval'd:
341 # src_unpack() { base_src_unpack; }
342 EXPORT_FUNCTIONS() {
343         if [ -z "$ECLASS" ]; then
344                 die "EXPORT_FUNCTIONS without a defined ECLASS"
345         fi
346         eval $__export_funcs_var+=\" $*\"
347 }
348
349 PORTAGE_BASHRCS_SOURCED=0
350
351 # @FUNCTION: source_all_bashrcs
352 # @DESCRIPTION:
353 # Source a relevant bashrc files and perform other miscellaneous
354 # environment initialization when appropriate.
355 #
356 # If EAPI is set then define functions provided by the current EAPI:
357 #
358 #  * default_* aliases for the current EAPI phase functions
359 #  * A "default" function which is an alias for the default phase
360 #    function for the current phase.
361 #
362 source_all_bashrcs() {
363         [[ $PORTAGE_BASHRCS_SOURCED = 1 ]] && return 0
364         PORTAGE_BASHRCS_SOURCED=1
365         local x
366
367         local OCC="${CC}" OCXX="${CXX}"
368
369         if [[ $EBUILD_PHASE != depend ]] ; then
370                 # source the existing profile.bashrcs.
371                 save_IFS
372                 IFS=$'\n'
373                 local path_array=($PROFILE_PATHS)
374                 restore_IFS
375                 for x in "${path_array[@]}" ; do
376                         [ -f "$x/profile.bashrc" ] && qa_source "$x/profile.bashrc"
377                 done
378
379                 # The user's bashrc is the ONLY non-portage bit of code that can
380                 # change shopts without a QA violation.
381                 for x in "${PM_EBUILD_HOOK_DIR}"/${CATEGORY}/{${PN},${PN}:${SLOT},${P},${PF}}; do
382                         if [ -r "${x}" ]; then
383                                 # If $- contains x, then tracing has already been enabled
384                                 # elsewhere for some reason. We preserve it's state so as
385                                 # not to interfere.
386                                 if [ "$PORTAGE_DEBUG" != "1" ] || [ "${-/x/}" != "$-" ]; then
387                                         source "${x}"
388                                 else
389                                         set -x
390                                         source "${x}"
391                                         set +x
392                                 fi
393                         fi
394                 done
395         fi
396
397         if [ -r "${PORTAGE_BASHRC}" ] ; then
398                 if [ "$PORTAGE_DEBUG" != "1" ] || [ "${-/x/}" != "$-" ]; then
399                         source "${PORTAGE_BASHRC}"
400                 else
401                         set -x
402                         source "${PORTAGE_BASHRC}"
403                         set +x
404                 fi
405         fi
406
407         [ ! -z "${OCC}" ] && export CC="${OCC}"
408         [ ! -z "${OCXX}" ] && export CXX="${OCXX}"
409 }
410
411 # === === === === === === === === === === === === === === === === === ===
412 # === === === === === functions end, main part begins === === === === ===
413 # === === === === === === === === === === === === === === === === === ===
414
415 export SANDBOX_ON="1"
416 export S=${WORKDIR}/${P}
417
418 # Turn of extended glob matching so that g++ doesn't get incorrectly matched.
419 shopt -u extglob
420
421 if [[ ${EBUILD_PHASE} == depend ]] ; then
422         QA_INTERCEPTORS="awk bash cc egrep equery fgrep g++
423                 gawk gcc grep javac java-config nawk perl
424                 pkg-config python python-config sed"
425 elif [[ ${EBUILD_PHASE} == clean* ]] ; then
426         unset QA_INTERCEPTORS
427 else
428         QA_INTERCEPTORS="autoconf automake aclocal libtoolize"
429 fi
430 # level the QA interceptors if we're in depend
431 if [[ -n ${QA_INTERCEPTORS} ]] ; then
432         for BIN in ${QA_INTERCEPTORS}; do
433                 BIN_PATH=$(type -Pf ${BIN})
434                 if [ "$?" != "0" ]; then
435                         BODY="echo \"*** missing command: ${BIN}\" >&2; return 127"
436                 else
437                         BODY="${BIN_PATH} \"\$@\"; return \$?"
438                 fi
439                 if [[ ${EBUILD_PHASE} == depend ]] ; then
440                         FUNC_SRC="${BIN}() {
441                                 if [ \$ECLASS_DEPTH -gt 0 ]; then
442                                         eqawarn \"QA Notice: '${BIN}' called in global scope: eclass \${ECLASS}\"
443                                 else
444                                         eqawarn \"QA Notice: '${BIN}' called in global scope: \${CATEGORY}/\${PF}\"
445                                 fi
446                         ${BODY}
447                         }"
448                 elif has ${BIN} autoconf automake aclocal libtoolize ; then
449                         FUNC_SRC="${BIN}() {
450                                 if ! has \${FUNCNAME[1]} eautoreconf eaclocal _elibtoolize \\
451                                         eautoheader eautoconf eautomake autotools_run_tool \\
452                                         autotools_check_macro autotools_get_subdirs \\
453                                         autotools_get_auxdir ; then
454                                         eqawarn \"QA Notice: '${BIN}' called by \${FUNCNAME[1]}: \${CATEGORY}/\${PF}\"
455                                         eqawarn \"Use autotools.eclass instead of calling '${BIN}' directly.\"
456                                 fi
457                         ${BODY}
458                         }"
459                 else
460                         FUNC_SRC="${BIN}() {
461                                 eqawarn \"QA Notice: '${BIN}' called by \${FUNCNAME[1]}: \${CATEGORY}/\${PF}\"
462                         ${BODY}
463                         }"
464                 fi
465                 eval "$FUNC_SRC" || echo "error creating QA interceptor ${BIN}" >&2
466         done
467         unset BIN_PATH BIN BODY FUNC_SRC
468 fi
469
470 # Subshell/helper die support (must export for the die helper).
471 export EBUILD_MASTER_PID=$BASHPID
472 trap 'exit 1' SIGTERM
473
474 if ! has "$EBUILD_PHASE" clean cleanrm depend && \
475         [ -f "${T}"/environment ] ; then
476         # The environment may have been extracted from environment.bz2 or
477         # may have come from another version of ebuild.sh or something.
478         # In any case, preprocess it to prevent any potential interference.
479         # NOTE: export ${FOO}=... requires quoting, unlike normal exports
480         preprocess_ebuild_env || \
481                 die "error processing environment"
482         # Colon separated SANDBOX_* variables need to be cumulative.
483         for x in SANDBOX_DENY SANDBOX_READ SANDBOX_PREDICT SANDBOX_WRITE ; do
484                 export PORTAGE_${x}="${!x}"
485         done
486         PORTAGE_SANDBOX_ON=${SANDBOX_ON}
487         export SANDBOX_ON=1
488         source "${T}"/environment || \
489                 die "error sourcing environment"
490         # We have to temporarily disable sandbox since the
491         # SANDBOX_{DENY,READ,PREDICT,WRITE} values we've just loaded
492         # may be unusable (triggering in spurious sandbox violations)
493         # until we've merged them with our current values.
494         export SANDBOX_ON=0
495         for x in SANDBOX_DENY SANDBOX_PREDICT SANDBOX_READ SANDBOX_WRITE ; do
496                 y="PORTAGE_${x}"
497                 if [ -z "${!x}" ] ; then
498                         export ${x}="${!y}"
499                 elif [ -n "${!y}" ] && [ "${!y}" != "${!x}" ] ; then
500                         # filter out dupes
501                         export ${x}="$(printf "${!y}:${!x}" | tr ":" "\0" | \
502                                 sort -z -u | tr "\0" ":")"
503                 fi
504                 export ${x}="${!x%:}"
505                 unset PORTAGE_${x}
506         done
507         unset x y
508         export SANDBOX_ON=${PORTAGE_SANDBOX_ON}
509         unset PORTAGE_SANDBOX_ON
510         [[ -n $EAPI ]] || EAPI=0
511 fi
512
513 if ! has "$EBUILD_PHASE" clean cleanrm ; then
514         if [[ $EBUILD_PHASE = depend || ! -f $T/environment || \
515                 -f $PORTAGE_BUILDDIR/.ebuild_changed ]] || \
516                 has noauto $FEATURES ; then
517                 # The bashrcs get an opportunity here to set aliases that will be expanded
518                 # during sourcing of ebuilds and eclasses.
519                 source_all_bashrcs
520
521                 # When EBUILD_PHASE != depend, INHERITED comes pre-initialized
522                 # from cache. In order to make INHERITED content independent of
523                 # EBUILD_PHASE during inherit() calls, we unset INHERITED after
524                 # we make a backup copy for QA checks.
525                 __INHERITED_QA_CACHE=$INHERITED
526
527                 # *DEPEND and IUSE will be set during the sourcing of the ebuild.
528                 # In order to ensure correct interaction between ebuilds and
529                 # eclasses, they need to be unset before this process of
530                 # interaction begins.
531                 unset DEPEND RDEPEND PDEPEND INHERITED IUSE REQUIRED_USE \
532                         ECLASS E_IUSE E_REQUIRED_USE E_DEPEND E_RDEPEND E_PDEPEND
533
534                 if [[ $PORTAGE_DEBUG != 1 || ${-/x/} != $- ]] ; then
535                         source "$EBUILD" || die "error sourcing ebuild"
536                 else
537                         set -x
538                         source "$EBUILD" || die "error sourcing ebuild"
539                         set +x
540                 fi
541
542                 if [[ "${EBUILD_PHASE}" != "depend" ]] ; then
543                         RESTRICT=${PORTAGE_RESTRICT}
544                         [[ -e $PORTAGE_BUILDDIR/.ebuild_changed ]] && \
545                         rm "$PORTAGE_BUILDDIR/.ebuild_changed"
546                 fi
547
548                 [[ -n $EAPI ]] || EAPI=0
549
550                 if has "$EAPI" 0 1 2 3 3_pre2 ; then
551                         export RDEPEND=${RDEPEND-${DEPEND}}
552                         debug-print "RDEPEND: not set... Setting to: ${DEPEND}"
553                 fi
554
555                 # add in dependency info from eclasses
556                 IUSE+="${IUSE:+ }${E_IUSE}"
557                 DEPEND+="${DEPEND:+ }${E_DEPEND}"
558                 RDEPEND+="${RDEPEND:+ }${E_RDEPEND}"
559                 PDEPEND+="${PDEPEND:+ }${E_PDEPEND}"
560                 REQUIRED_USE+="${REQUIRED_USE:+ }${E_REQUIRED_USE}"
561                 
562                 unset ECLASS E_IUSE E_REQUIRED_USE E_DEPEND E_RDEPEND E_PDEPEND \
563                         __INHERITED_QA_CACHE
564
565                 # alphabetically ordered by $EBUILD_PHASE value
566                 case "$EAPI" in
567                         0|1)
568                                 _valid_phases="src_compile pkg_config pkg_info src_install
569                                         pkg_nofetch pkg_postinst pkg_postrm pkg_preinst pkg_prerm
570                                         pkg_setup src_test src_unpack"
571                                 ;;
572                         2|3|3_pre2)
573                                 _valid_phases="src_compile pkg_config src_configure pkg_info
574                                         src_install pkg_nofetch pkg_postinst pkg_postrm pkg_preinst
575                                         src_prepare pkg_prerm pkg_setup src_test src_unpack"
576                                 ;;
577                         *)
578                                 _valid_phases="src_compile pkg_config src_configure pkg_info
579                                         src_install pkg_nofetch pkg_postinst pkg_postrm pkg_preinst
580                                         src_prepare pkg_prerm pkg_pretend pkg_setup src_test src_unpack"
581                                 ;;
582                 esac
583
584                 DEFINED_PHASES=
585                 for _f in $_valid_phases ; do
586                         if declare -F $_f >/dev/null ; then
587                                 _f=${_f#pkg_}
588                                 DEFINED_PHASES+=" ${_f#src_}"
589                         fi
590                 done
591                 [[ -n $DEFINED_PHASES ]] || DEFINED_PHASES=-
592
593                 unset _f _valid_phases
594
595                 if [[ $EBUILD_PHASE != depend ]] ; then
596
597                         if has distcc $FEATURES ; then
598                                 [[ -n $DISTCC_LOG ]] && addwrite "${DISTCC_LOG%/*}"
599                         fi
600
601                         if has ccache $FEATURES ; then
602
603                                 if [[ -n $CCACHE_DIR ]] ; then
604                                         addread "$CCACHE_DIR"
605                                         addwrite "$CCACHE_DIR"
606                                 fi
607
608                                 [[ -n $CCACHE_SIZE ]] && ccache -M $CCACHE_SIZE &> /dev/null
609                         fi
610
611                         if [[ -n $QA_PREBUILT ]] ; then
612
613                                 # these ones support fnmatch patterns
614                                 QA_EXECSTACK+=" $QA_PREBUILT"
615                                 QA_TEXTRELS+=" $QA_PREBUILT"
616                                 QA_WX_LOAD+=" $QA_PREBUILT"
617
618                                 # these ones support regular expressions, so translate
619                                 # fnmatch patterns to regular expressions
620                                 for x in QA_DT_NEEDED QA_FLAGS_IGNORED QA_PRESTRIPPED QA_SONAME ; do
621                                         if [[ $(declare -p $x 2>/dev/null) = declare\ -a* ]] ; then
622                                                 eval "$x=(\"\${$x[@]}\" ${QA_PREBUILT//\*/.*})"
623                                         else
624                                                 eval "$x+=\" ${QA_PREBUILT//\*/.*}\""
625                                         fi
626                                 done
627
628                                 unset x
629                         fi
630
631                         # This needs to be exported since prepstrip is a separate shell script.
632                         [[ -n $QA_PRESTRIPPED ]] && export QA_PRESTRIPPED
633                         eval "[[ -n \$QA_PRESTRIPPED_${ARCH/-/_} ]] && \
634                                 export QA_PRESTRIPPED_${ARCH/-/_}"
635                 fi
636         fi
637 fi
638
639 # unset USE_EXPAND variables that contain only the special "*" token
640 for x in ${USE_EXPAND} ; do
641         [ "${!x}" == "*" ] && unset ${x}
642 done
643 unset x
644
645 if has nostrip ${FEATURES} ${RESTRICT} || has strip ${RESTRICT}
646 then
647         export DEBUGBUILD=1
648 fi
649
650 if [[ $EBUILD_PHASE = depend ]] ; then
651         export SANDBOX_ON="0"
652         set -f
653
654         if [ -n "${dbkey}" ] ; then
655                 if [ ! -d "${dbkey%/*}" ]; then
656                         install -d -g ${PORTAGE_GID} -m2775 "${dbkey%/*}"
657                 fi
658                 # Make it group writable. 666&~002==664
659                 umask 002
660         fi
661
662         auxdbkeys="DEPEND RDEPEND SLOT SRC_URI RESTRICT HOMEPAGE LICENSE
663                 DESCRIPTION KEYWORDS INHERITED IUSE REQUIRED_USE PDEPEND PROVIDE EAPI
664                 PROPERTIES DEFINED_PHASES UNUSED_05 UNUSED_04
665                 UNUSED_03 UNUSED_02 UNUSED_01"
666
667         [ -n "${EAPI}" ] || EAPI=0
668
669         # The extra $(echo) commands remove newlines.
670         if [ -n "${dbkey}" ] ; then
671                 > "${dbkey}"
672                 for f in ${auxdbkeys} ; do
673                         echo $(echo ${!f}) >> "${dbkey}" || exit $?
674                 done
675         else
676                 for f in ${auxdbkeys} ; do
677                         echo $(echo ${!f}) 1>&9 || exit $?
678                 done
679                 exec 9>&-
680         fi
681         set +f
682 else
683         # Note: readonly variables interfere with preprocess_ebuild_env(), so
684         # declare them only after it has already run.
685         declare -r $PORTAGE_READONLY_METADATA $PORTAGE_READONLY_VARS
686         case "$EAPI" in
687                 0|1|2)
688                         [[ " ${FEATURES} " == *" force-prefix "* ]] && \
689                                 declare -r ED EPREFIX EROOT
690                         ;;
691                 *)
692                         declare -r ED EPREFIX EROOT
693                         ;;
694         esac
695
696         if [[ -n $EBUILD_SH_ARGS ]] ; then
697                 (
698                         # Don't allow subprocesses to inherit the pipe which
699                         # emerge uses to monitor ebuild.sh.
700                         exec 9>&-
701                         ebuild_main ${EBUILD_SH_ARGS}
702                         exit 0
703                 )
704                 exit $?
705         fi
706 fi
707
708 # Do not exit when ebuild.sh is sourced by other scripts.
709 true